<?php

namespace App\Http\Controllers;

use App\Models\FotoBug;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class FotoBugController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = FotoBug::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new FotoBug())->getFillable());
        $fotoBug = FotoBug::create($payload);

        return response()->json([
            'success' => true,
            'data' => $fotoBug,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(FotoBug $fotoBug): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $fotoBug,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, FotoBug $fotoBug): JsonResponse
    {
        $payload = $request->only((new FotoBug())->getFillable());
        $fotoBug->update($payload);

        return response()->json([
            'success' => true,
            'data' => $fotoBug,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(FotoBug $fotoBug): JsonResponse
    {
        $fotoBug->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}